#!/bin/bash
 
if [ $# != 3 ]; then
  echo "Usage:  resize_pngs <% x ORIGIN> <crush [1|0]> <path/to/images>\n"
  exit 1
fi
 
IMG_DIR="$3"
NEW_DIR="${IMG_DIR##*/}.resized.$1"
DIRS=( "century_school-bold-roman-serif-vari" "century_school-medium-roman-serif-vari" "courier-medium-roman-serif-mono" )
 
mkdir $NEW_DIR
 
for dir in "${DIRS[@]}"
do
  mkdir $NEW_DIR/$dir
  cd $IMG_DIR/$dir
  FILES=*.png
  for png in $FILES
  do
    convert $png -antialias  -resize $1% ../../$NEW_DIR/$dir/tmp.png
    if [ $2 == 1 ]; then
      ../../pngcrush -keep  pHYs -rem gAMA -blacken -rem cHRM -rem iCCP -rem sRGB -rem alla -rem text -rem time -rem tRNS ../../$NEW_DIR/$dir/tmp.png ../../$NEW_DIR/$dir/$png
    else
      cp ../../$NEW_DIR/$dir/tmp.png ../../$NEW_DIR/$dir/$png  
    fi
  done
  cd ../..
done
